#include "stdafx.h"
#include <windows.h>
#include "BasicLib.h"

VOID StringToLower(IN char *String,OUT char *OutString)
{
	int i;
	//printf("stringlen = %d\n",strlen(String));
	for(i = 0; i < strlen(String); i++)
	{
		if((String[i] >= 'A') && (String[i] <= 'Z'))
			OutString[i] = String[i] + 0x20;
		else OutString[i] = String[i];
		//printf("%c",OutString[i]);
	}
	OutString[i] = '\0';
}

VOID UnicodeStringToString(IN BYTE *UnicodeInputData, OUT char *String)
{
	int i = 0;
	for(i = 0; i < UnicodeInputData[0] / sizeof(wchar_t); i++)
	{
		(char)*(String + i) = UnicodeInputData[2 + i * sizeof(wchar_t)];
		//printf("%c",String[i]);
	}
	(char)*(String + i) = '\0';
	//printf("%x\n",UnicodeInputData[0] / sizeof(wchar_t));
}

VOID StringToUnicodeStringWithOffset(IN char *String, IN BYTE InputDataOffset, OUT BYTE *UnicodeInputData)
{
	BYTE StringSize = 0, MaxStringSize = 0;

	StringSize = (BYTE) (strlen(String) * sizeof(wchar_t));
	//printf("wcslen(String) = %d, StringSize = %d\n",wcslen(String),StringSize);

	UnicodeInputData[InputDataOffset] = StringSize;
	UnicodeInputData[InputDataOffset + 1] = MaxStringSize;

	for(int i = 0; i < StringSize; i++)
	{
		UnicodeInputData[InputDataOffset + 2 + i * sizeof(wchar_t)] = (wchar_t)*(String + i);
		//printf("UnicodeInputData->InputData[%d] = %02x\n",InputDataOffset + i + 2,UnicodeInputData[InputDataOffset + 2 + i]);
	}
}

BYTE CharToHexData(IN BYTE SingleChar)
{
	if(SingleChar>='0' && SingleChar<='9')
		return (SingleChar-'0');
	if(SingleChar>='A' && SingleChar<='F')
		return (SingleChar-'0'-7);
	if(SingleChar>='a' && SingleChar<='f')
		return (SingleChar-'0'-39);
}

int StringToHexByteWithOffset(IN FORMATLIST HexFormat,IN char *String, IN BYTE ConvertStart, OUT BYTE *HexData)
{
	BYTE StringSize = 0;
	int Index = 0, HexIndex = ConvertStart;
	char StringTemp[17]; //Maxlength is uint64, eg. 01234567 89ABCDEF, 16 chars.


	StringSize = strlen(String);

	for ( Index = 0; Index < HexFormat*2 - StringSize; Index ++ ) //eg.uint16 = 2 bytes, 4 chars
	{
		StringTemp[Index] = '0';
	}
	for ( ; Index < HexFormat*2 ; Index ++ )
	{
		StringTemp[Index] = String[Index - (HexFormat*2 - StringSize)];
	}
	StringTemp[Index] = '\0';

	for ( Index = ((HexFormat*2)-1); Index >= 0; Index = Index - 2)
	{
	   if((StringTemp[Index]>='0' && StringTemp[Index]<='9') || (StringTemp[Index] >= 'A') && (StringTemp[Index] <= 'F') || (StringTemp[Index] >= 'a') && (StringTemp[Index] <= 'f'))
	   {
	       HexData[HexIndex] = CharToHexData(StringTemp[Index]) + CharToHexData(StringTemp[Index - 1])*16;//(StringTemp[Index] - '0') + ( StringTemp[Index - 1] - '0') * 16; //for BYTE 
	   }
	   /*else if((StringTemp[Index] >= 'A') && (StringTemp[Index] <= 'F'))
	   {
		   HexData[HexIndex] = (StringTemp[Index] - '0' - 7) + ( StringTemp[Index - 1] - '0' - 7) * 16;
	   }
	   else if((StringTemp[Index] >= 'a') && (StringTemp[Index] <= 'f'))
	   {
		   HexData[HexIndex] = (StringTemp[Index] - '0'- 39) + ( StringTemp[Index - 1] - '0' - 39) * 16;
	   }*/
	   else
	   {
		   printf("\n  InputData Error.\n");
		   return 0;
	   }
	   //printf("Hex[%02x] = %02x\n",HexIndex,HexData[HexIndex]);
	   HexIndex ++;
	}
	return 1;
}


//eg. SetOptionDefault([in] String OptionName, [in] uint32 Value), the numberic var need to align the length that var definded.
//    OptionName=FastBoot, Value=1, the follow is binary format:
//    UnicodeString=FastBoot, length=18 bytes. definded var is uint32, sizeof(unit32)=4 bytes. 18 mod 4 = 2 bytes, so the Value need to start from 18+(4-2)=20 bytes.
//      00460010 00730061 00420074 006F006F
//      00000074 00000001
int StringConvert(IN char StringBuff[][0x70], IN INPUT_BUFF_FORMAT InputFormat, OUT BYTE *ConvertData)
{
  BYTE    Index = 0, IndexHead = 0, IndexTail = 0, Status = 1;

  for (BYTE Count = 0; Count < InputFormat.DataCount ; Count++)
  {
	  if(InputFormat.FormatBuff[Count] == UnicodeString)
	  {
		 StringToUnicodeStringWithOffset(StringBuff[Count], IndexHead, ConvertData);
		 //IndexTail = IndexHead; //UnicodeString, ignore IndexTail, the next need to start with IndexHead.  
		 IndexHead = IndexHead + strlen(StringBuff[Count])*sizeof(wchar_t) + UnicodeStringOffset;
		 IndexTail = IndexHead;
	  }
	  else if(InputFormat.FormatBuff[Count] == HexUint8)
	  {
		 IndexTail = IndexHead;
		 Status = StringToHexByteWithOffset(HexUint8,StringBuff[Count], IndexHead, ConvertData);
		 IndexHead = IndexHead + sizeof(UINT8);
	  }
	  else if(InputFormat.FormatBuff[Count] == HexUint16)
	  {
		 UINT8           AlignByte;

		 if(IndexTail % sizeof(UINT16) == 0) 
			 AlignByte = 0;
		 else
		 {
		     AlignByte = sizeof(UINT16) - (IndexTail % sizeof(UINT16)); 
		 }
		 IndexHead = max(IndexTail + AlignByte,IndexHead);
		 IndexTail = IndexHead;
		 Status = StringToHexByteWithOffset(HexUint16,StringBuff[Count], IndexHead, ConvertData);
		 IndexHead = IndexHead + sizeof(UINT16);
	  }
	  else if(InputFormat.FormatBuff[Count] == HexUint32)
	  {
		 UINT8           AlignByte;

		 if(IndexTail % sizeof(UINT32) == 0) 
			 AlignByte = 0;
		 else
		 {
		     AlignByte = sizeof(UINT32) - (IndexTail % sizeof(UINT32)); 
		 }
		 IndexHead = max(IndexTail + AlignByte,IndexHead);
		 IndexTail = IndexHead;
		 Status = StringToHexByteWithOffset(HexUint32,StringBuff[Count], IndexHead, ConvertData);
		 IndexHead = IndexHead + sizeof(UINT32);
	  }
	  else if(InputFormat.FormatBuff[Count] == HexUint64)
	  {
		 UINT8           AlignByte;

		 if(IndexTail % sizeof(UINT64) == 0) 
			 AlignByte = 0;
		 else
		 {
		     AlignByte = sizeof(UINT64) - (IndexTail % sizeof(UINT64)); 
		 }
		 IndexHead = max(IndexTail + AlignByte,IndexHead);
		 IndexTail = IndexHead;
		 Status = StringToHexByteWithOffset(HexUint64,StringBuff[Count], IndexHead, ConvertData);
		 IndexHead = IndexHead + sizeof(UINT64);
	  }
  }

  if (Status == 0) return 0;
  if (Status == 1) return 1;
}